#It is presumed that QuickField is already started, the problem coil.pbm is opened.
#The plunger is placed in x=0 position
#LabelMover file relay.qva is opened

import win32com.client


def getQfForceX(x_position):
#calculate force in QuickField
# 0. hook LabelMover (QuickField tool)
    qlm = win32com.client.Dispatch("qlm.SimpleInterface")
# 1. set plunger position
    qlm.SetVariation (0, x_position)
# 2. get the force
    qlm.Solve()
    return qlm.GetResult(0)
# each step is stored in LabelMover






#relay physical parameters
x_out = 0.01       		# pull out position. m
x_in = 0.006       		# pull in position, m
m_mass = 0.0045     	# plunger weight, kg
k = 4.0            		# spring constant, N/m
x_spring_free = 0.015  	# spring free would be position, m


#initial conditions
t_time = 0.0    		# time, s
x_position = x_out  	# plunger position, m
v_speed = 0.0         	# plunger speed, m/s


dt_time_step = 0.005	#integration time step, s
max_time = 0.2        	# maximal integration time

print("Time [s]	Position [m]	Speed[m/s]")

while ((t_time < max_time) and (x_position > x_in)):
    theForce = getQfForceX(x_position)				# electromagnetic force
    theForce = theForce + (x_spring_free - x_position) * k	# add spring force
    v_speed = v_speed + theForce / m_mass * dt_time_step 	# calculate acceleration and speed
    x_position = x_position + v_speed * dt_time_step		# calculate plunger position
    t_time = t_time + dt_time_step
    print(t_time,"	",x_position,"	",v_speed)
    #output results are stored in LabelMover










